import {
  replaceKwithBox
} from "./chunk-CXVFFB5B.mjs";
import {
  collectImportedStyled
} from "./chunk-KPGST4LK.mjs";
import {
  ensureReactImport
} from "./chunk-ESV3MQV2.mjs";
import {
  hasCoreImportDeclaration
} from "./chunk-TKCPTVA7.mjs";
import {
  importBox
} from "./chunk-XKMXMLOA.mjs";

// src/visitor.ts
var styledFunctionsMap = /* @__PURE__ */ new Map();
var visitor = ({ types: t, template }) => {
  let importedStyleFunctions = {};
  const visitor2 = {
    Program: {
      enter(path) {
        if (!hasCoreImportDeclaration(path)) {
          return;
        }
        ensureReactImport(path, t);
        importedStyleFunctions = collectImportedStyled(path, t);
        importBox(path, importedStyleFunctions);
        replaceKwithBox(path, t, importedStyleFunctions);
      },
      exit() {
        this.file.metadata.bindings = importedStyleFunctions;
      }
    }
  };
  return visitor2;
};

export {
  styledFunctionsMap,
  visitor
};
