// src/collectImportedStyled.ts
function collectImportedStyled(path, t) {
  const importedStyleFunctions = {};
  const importDeclarations = path.get("body").filter((node) => t.isImportDeclaration(node.node));
  for (const importDeclaration of importDeclarations) {
    if (t.isImportDeclaration(importDeclaration.node) && importDeclaration.node.source.value === "@kuma-ui/core") {
      for (const specifier of importDeclaration.node.specifiers) {
        if (t.isImportSpecifier(specifier) && t.isIdentifier(specifier.imported)) {
          importedStyleFunctions[specifier.imported.name] = specifier.local.name;
        }
      }
    }
  }
  return importedStyleFunctions;
}

export {
  collectImportedStyled
};
