// src/importBox.ts
import { types as t } from "@babel/core";
function importBox(node, importedStyleFunctions) {
  let boxName = importedStyleFunctions["Box"];
  if (!boxName) {
    const localBoxName = "__Box";
    const reactImportDeclaration = t.importDeclaration(
      [t.importSpecifier(t.identifier(localBoxName), t.identifier("Box"))],
      t.stringLiteral("@kuma-ui/core")
    );
    node.unshiftContainer("body", reactImportDeclaration);
    boxName = localBoxName;
  }
  importedStyleFunctions["Box"] = boxName;
}

export {
  importBox
};
