import { NodePath, types } from '@babel/core';

/**
 * Transforms a Spacer JSXElement to include specific style attributes.
 * Removes 'size' and 'horizontal' attributes and adds 'display', 'flexShrink',
 * 'width', and 'height' attributes based on the original attributes.
 *
 * @param {NodePath<t.JSXElement>} path - The JSXElement NodePath to transform.
 */
declare const handleSpacer: (path: NodePath<types.JSXElement>) => void;

export { handleSpacer };
