import { NodePath, types } from '@babel/core';

/**
 * Checks if the given AST program has an import declaration for "@kuma-ui/core".
 *
 * @param {NodePath<types.Program>} path - The current node in the AST being traversed.
 * @returns {boolean} - Returns true if a core import declaration exists, otherwise false.
 */
declare function hasCoreImportDeclaration(path: NodePath<types.Program>): boolean;

export { hasCoreImportDeclaration };
