import { NodePath, types } from '@babel/core';

/**
 * If the 'Box' component is not imported, this function will create a new import statement for the 'Box' component
 * from '@kuma-ui/core' with the local name '__Box'.
 *
 * @param {NodePath<types.Program>} node - The NodePath object representing the Program node.
 * @param {Record<string, string>} importedStyleFunctions - An object containing the imported styled functions.
 */
declare function importBox(node: NodePath<types.Program>, importedStyleFunctions: Record<string, string>): void;

export { importBox };
